﻿using System;
using System.ServiceModel;
using System.ServiceModel.Security;
using System.ServiceModel.Description;
using System.Security.Cryptography.X509Certificates;

namespace Host
{
    class Program
    {
        static void Main(string[] args)
        {
            using (ServiceHost host = new ServiceHost(typeof(Servico),
                new Uri[] { new Uri("http://localhost:2999/") }))
            {
                WSHttpBinding binding = new WSHttpBinding(SecurityMode.Message);

                ServiceCredentials credenciais = new ServiceCredentials();
                credenciais.UserNameAuthentication.UserNamePasswordValidationMode = 
                    UserNamePasswordValidationMode.Custom;
                credenciais.UserNameAuthentication.CustomUserNamePasswordValidator = new Autenticador();
                credenciais.ServiceCertificate.SetCertificate(
                    StoreLocation.LocalMachine,
                    StoreName.My,
                    X509FindType.FindBySerialNumber,
                    "3c f2 d0 c0 ef 8e 0a 96 42 36 e6 54 5f 67 50 e0");

                host.Description.Behaviors.Add(credenciais);

                host.Description.Behaviors.Add(new ServiceMetadataBehavior() { HttpGetEnabled = true });
                host.AddServiceEndpoint(typeof(IContrato), binding, "srv");
                host.AddServiceEndpoint(typeof(IMetadataExchange), MetadataExchangeBindings.CreateMexHttpBinding(), "mex");

                host.Open();
                Console.ReadLine();
            }
        }
    }
}